/***********************************************************************************/
/*                                                                                 */
/*                      Bloom Entity Class Definition                              */
/*                                                                                 */
/***********************************************************************************/

#include <iostream>
#include "bloomEntity.h"

using namespace std;

BloomEntity::BloomEntity(float x, float y) : Entity(x, y)
{
	textureType = TEX_BLOOM;
	collideType = CT_NOHIT;

	status = 0;
	age=0;
}

void BloomEntity::updateEntity()
{
	age++;

	if(status == BLOOM_FADE)
	{
		if(age>20)
			life=0;

		setGlowAlpha(glowColour.a*0.9f);
	}
}


void BloomEntity::collideResponse(Vector proj, Entity* ent)
{
	//no response to collisions
}
