/***********************************************************************************/
/*                                                                                 */
/*                      Bloom Entity Class Declaration                             */
/*                                                                                 */
/***********************************************************************************/

/*
The bloom entity class is a non-colliding derivative of the Entity class.
It is used to tint the screen in a specific position for decorative effect. 
Many bloom entities can be used to make up glowing trails and lines.
*/


#ifndef BLOOMENT_H
#define BLOOMENT_H
#include "entity.h"

enum
{
	BLOOM_FADE,
	BLOOM_FIXED
};

class BloomEntity : public Entity
{
public:
	BloomEntity(float x, float y);

	void updateEntity();
	void collideResponse(Vector proj, Entity* ent);

};

#endif