/***********************************************************************************/
/*                                                                                 */
/*                          Borealis Class Definition                              */
/*                                                                                 */
/***********************************************************************************/


#include <iostream>
#include "borealis.h"
#include "math.h"

using namespace std;

Borealis::Borealis()
{
	colour1.r = 0.0f;
	colour1.b = 0.0f;
	colour1.g = 0.0f;
	colour1.a = 0.0f;

	colour2.r = 0.0f;
	colour2.b = 0.0f;
	colour2.g = 0.0f;
	colour2.a = 0.0f;

	colour3.r = 0.0f;
	colour3.b = 0.0f;
	colour3.g = 0.0f;
	colour3.a = 0.0f;

	colour4.r = 0.0f;
	colour4.b = 0.0f;
	colour4.g = 0.0f;
	colour4.a = 0.0f;

	colour5.r = 0.0f;
	colour5.b = 0.0f;
	colour5.g = 0.0f;
	colour5.a = 0.0f;
	
	default1 = target1 = colour1;
	default2 = target2 = colour2;
	default3 = target3 = colour3;
	default4 = target4 = colour4;	
	default5 = target5 = colour5;

}

void Borealis::update(void)
{
	target1 = shiftColour(target1, default1, 0.005f);
	target2 = shiftColour(target2, default2, 0.005f);
	target3 = shiftColour(target3, default3, 0.005f);
	target4 = shiftColour(target4, default4, 0.005f);
	target5 = shiftColour(target5, default5, 0.005f);

	float variance = 0.1f;
	float offset = variance/2.0f;

	if(rand()%100 == 0)
	{
		float t = ((float)rand()/RAND_MAX);
		colour temp;
		temp.r = (t*default5.r) + ((1.0f-t)*default1.r);
		temp.g = (t*default5.g) + ((1.0f-t)*default1.g);
		temp.b = (t*default5.b) + ((1.0f-t)*default1.b);
		temp.a = (t*default5.a) + ((1.0f-t)*default1.a);

		temp.a += 0.6f*((float)rand()/RAND_MAX)-0.3f;

		switch( (int)(5*((float)rand()/RAND_MAX)) )
		{
			case 0:
				target1 = temp;
				break;
			case 1:
				target2 = temp;
				break;
			case 2:
				target3 = temp;
				break;
			case 3:
				target4 = temp;
				break;
			case 4:
				target5 = temp;
				break;
		}
	}

	colour1 = shiftColour(colour1, target1, 0.05f);
	colour2 = shiftColour(colour2, target2, 0.05f);
	colour3 = shiftColour(colour3, target3, 0.05f);
	colour4 = shiftColour(colour4, target4, 0.05f);
	colour5 = shiftColour(colour5, target5, 0.05f);
}


void Borealis::setDefaultColours(colour c1, colour c2)
{
	float t;

	default1 = c1;

	t = 0.25f;

	default2.r = (t*c2.r) + ((1.0f-t)*c1.r);
	default2.g = (t*c2.g) + ((1.0f-t)*c1.g);
	default2.b = (t*c2.b) + ((1.0f-t)*c1.b);
	default2.a = (t*c2.a) + 0.7f*((1.0f-t)*c1.a);

	t = 0.5f;

	default3.r = (t*c2.r) + ((1.0f-t)*c1.r);
	default3.g = (t*c2.g) + ((1.0f-t)*c1.g);
	default3.b = (t*c2.b) + ((1.0f-t)*c1.b);
	default3.a = (t*c2.a) + 0.5f*((1.0f-t)*c1.a);

	t = 0.75f;

	default4.r = (t*c2.r) + ((1.0f-t)*c1.r);
	default4.g = (t*c2.g) + ((1.0f-t)*c1.g);
	default4.b = (t*c2.b) + ((1.0f-t)*c1.b);
	default4.a = (t*c2.a) + 0.7f*((1.0f-t)*c1.a);

	default5 = c2;
}


colour Borealis::shiftColour(colour base, colour target, float shift)
{
	if(base.r != target.r)
	{
		base.r += shift*(target.r - base.r);
	}
	if(base.g != target.g)
	{
		base.g += shift*(target.g - base.g);
	}

	if(base.b != target.b)
	{
		base.b += shift*(target.b - base.b);
	}

	if(base.a != target.a)
	{
		base.a += shift*(target.a - base.a);
	}

	return base;
}