/***********************************************************************************/
/*                                                                                 */
/*                          Borealis Class Declaration                             */
/*                                                                                 */
/***********************************************************************************/

/*
The borealis class contains a set of colour values which are used to determine
the colour of the "aurora borealis" in the background of the scene.
The borealis' update function causes the colour and opacity to fluctuate
randomly. The colour of the borealis can be changed mid-game to reflect the
foreground action, and the new colour will be smoothly interpolated.
*/

#ifndef BOREALIS_H
#define BOREALIS_H
#include "entity.h"

class Borealis
{
public:
	colour colour1, colour2, colour3, colour4, colour5;
	colour target1, target2, target3, target4, target5;
	colour default1, default2, default3, default4, default5;

	Borealis();
	void update(void);
	void setDefaultColours(colour c1, colour c2);
	colour shiftColour(colour base, colour target, float shift);
};


#endif