/***********************************************************************************/
/*                                                                                 */
/*                       Cloud Entity Class Definition                             */
/*                                                                                 */
/***********************************************************************************/


#include <iostream>
#include "cloudEntity.h"
#include "math.h"


CloudEntity::CloudEntity(float x, float y) : DynamicEntity(x, y)
{
	collideType = CT_NOHIT;
	textureType = TEX_CLOUD;

	setGlowColour(0.6f, 0.5f, 1.0f, 1.0f);
	glowColourDefault.r = targetColour.r = glowColour.r;
	glowColourDefault.g = targetColour.g = glowColour.g;
	glowColourDefault.b = targetColour.b = glowColour.b;
	glowColourDefault.a = targetColour.a = glowColour.a;

	setLineAlpha(0.0f);
	setSize( 5.0f*(((float)rand()/(RAND_MAX/* + 1*/))+0.5f) );

	setVelX( 0.05f* (((float)rand()/RAND_MAX)-0.5f) * (getSize()/3.5f) );
	setVelY( 0.05f* (((float)rand()/RAND_MAX)-0.5f) * (getSize()/3.5f) );

	rotate = 0;

	status=1.0f;
}


void CloudEntity::updateEntity()
{
	//Update cloud position according to the current velocity.

	setPosX( getPosX() + getVelX() );
	setPosY( getPosY() + getVelY() );

	//Update colours
	targetColour = shiftColour(targetColour, glowColourDefault, 0.001f);
	glowColour = shiftColour(glowColour, targetColour, 0.005f);

	if(rand()%1000 == 0)
		targetColour.a *= 0.1f;

	age++;
}

void CloudEntity::collideResponse(Vector proj, DynamicEntity* ent)
{
 //no response to collisions
}
