/***********************************************************************************/
/*                                                                                 */
/*                       Cloud Entity Class Declaration                            */
/*                                                                                 */
/***********************************************************************************/

/*
The cloud entity is a non-colliding derivative of the dynamic entity. Its velocity
is slow but constant, with no damping or gravity applied, and its opacity fades
slowly in and out.
*/


#ifndef CLOUDENT_H
#define CLOUDENT_H
#include "dynamicEntity.h"

class CloudEntity : public DynamicEntity
{
	public:
		CloudEntity(float x = 0, float y = 0);
		void updateEntity(void);
		void collideResponse(Vector proj, DynamicEntity* ent);

};

#endif