/***********************************************************************************/
/*                                                                                 */
/*                         Input Handler Class Declaration                         */
/*                                                                                 */
/***********************************************************************************/

#ifndef INPUTHANDLER_H
#define INPUTHANDLER_H

#include "SDL.h"
#ifdef WIN32
	#include <windows.h>
#endif 
#include <GL/gl.h>
#include <GL/glu.h>
#include <IL/il.h>
#include <IL/ilut.h>
#include <IL/ilu.h>
#include "scene.h"
#include "list.h"
#include "entity.h"
#include "mouseEntity.h"
#include "math.h"


class InputHandler
{

public:
	InputHandler(Scene* scenePtr_);
	bool setScene(Scene* scenePtr_);
	bool handleEvents();
	void updateMouse();

private:
	Scene* scenePtr;
	PlayerEntity* playerPtr;
	Entity* cameraPtr;
	MouseEntity* mousePtr;

	Uint8 *keystate;
	Uint8 mousestate;
	int mousePosX;
	int mousePosY;


};

#endif