/***********************************************************************************/
/*                                                                                 */
/*                       Spark Entity Class Declaration                            */
/*                                                                                 */
/***********************************************************************************/

/*
The spark entity is a derivative of the dynamic entity, with altered collision behaviour. 
Sparks will bounce energetically away from collision events, with a element of randomness
to their movement. A spark entity will become smaller and will die after a few collide events.
*/

#ifndef SPARKENT_H
#define SPARKENT_H
#include "dynamicEntity.h"

class SparkEntity : public DynamicEntity
{
	public:
		SparkEntity(float x = 0, float y = 0);
		void updateEntity();
		void collideResponse(Vector, DynamicEntity*);


};


#endif