/***********************************************************************************/
/*                                                                                 */
/*                       Star Entity Class Definition                              */
/*                                                                                 */
/***********************************************************************************/

#include <iostream>
#include "starEntity.h"

using namespace std;

StarEntity::StarEntity(float x, float y) : Entity(x, y)
{
	textureType = TEX_STAR;
	collideType = CT_NOHIT;

	status = 0;
	age=0;

	setSize( 0.1f*((float)rand()/(RAND_MAX)) + 0.1f );
	setLineAlpha(0.25f*((float)rand()/(RAND_MAX)) + 0.05f);
	setGlowColour(1.0f, 1.0f, 1.0f, getLineAlpha() );
	
	glowColourDefault.r=targetColour.r=glowColour.r=1.0f;
	glowColourDefault.g=targetColour.g=glowColour.g=1.0f;
	glowColourDefault.b=targetColour.b=glowColour.b=1.0f;
	glowColourDefault.a=targetColour.a=glowColour.a= getLineAlpha();

	setGlowColour(1.0f, 1.0f, 1.0f, 0.0f );
	setLineAlpha(0.0f);

}

void StarEntity::updateEntity()
{
	if( targetColour.a < glowColourDefault.a )
	{
		targetColour.a += 0.01f;
	}
	else if( targetColour.a > glowColourDefault.a )
	{
		targetColour.a -= 0.01f;
	}

	if( glowColour.a < targetColour.a )
	{
		glowColour.a += 0.03f;
		setLineAlpha(glowColour.a);
	}
	else if( glowColour.a > targetColour.a )
	{
		glowColour.a -= 0.03f;
		setLineAlpha(glowColour.a);
	}


	if( rand()%80 == 0)
		targetColour.a = glowColourDefault.a + ( ((float)rand()/(RAND_MAX)) - 0.5f);


	age++;
}

void StarEntity::collideResponse(Vector proj, Entity* ent)
{
	//no response to collisions
}
