/***********************************************************************************/
/*                                                                                 */
/*                       Star Entity Class Declaration                             */
/*                                                                                 */
/***********************************************************************************/

/*
The star entity is a derivative of the entity class, used to place
stars in the background of the scene. The star is given a random size
and brightness at birth, and the update function causes the opacity 
to gently fluctuate.
*/

#ifndef STARENT_H
#define STARENT_H
#include "entity.h"


class StarEntity : public Entity
{
public:
	StarEntity(float x, float y);

	void updateEntity();
	void collideResponse(Vector proj, Entity* ent);

};

#endif