/***********************************************************************************/
/*                                                                                 */
/*                         Vector Class Implementation                             */
/*                                                                                 */
/***********************************************************************************/

#include <iostream>
#include "vector.h"
#include "math.h"

using namespace std;

/*--------------Constructor------------*/

Vector::Vector(float X, float Y, float Z)
{
	x = X;
	y = Y;
	z = Z;
}



/*-------------Overloaded operators-----------*/


/*----Addition----*/

Vector Vector::operator+(const Vector &vec)
{
	return Vector(vec.x + x, vec.y + y, vec.z + z);
}

Vector Vector::operator+=(const Vector &vec)
{
	//Adds argument vector to current vector (*this) using overloaded '+'.
	//Result is saved into current vector (*this).
	//Returns successful or not.
	return ( *this = (*this + vec) );
}



/*----Subraction----*/

Vector Vector::operator-(const Vector &vec)
{
	return Vector(x - vec.x, y - vec.y, z - vec.z);
}

Vector Vector::operator-=(const Vector &vec)
{
	return ( *this = (*this - vec) );
}

Vector Vector::operator-(void)
{
	return Vector(-x, -y, -z);
}

/*------Scalar Multiplication-------*/

Vector Vector::operator*(float scale)
{
	return Vector(x * scale, y * scale, z * scale);
}

Vector Vector::operator*=(float scale)
{
	return ( *this = (*this * scale) );
}



/*-------Scalar Division--------*/

Vector Vector::operator/(float num)
{
	return Vector(x / num, y / num, z / num);
}

Vector Vector::operator/=(float num)
{
	return ( *this = (*this / num) );
}


/*-------Magnitude--------*/

float Vector::getMagnitude(void)
{
	return (float)sqrt( (double)(x*x + y*y) );
}