/***********************************************************************************/
/*                                                                                 */
/*                         Vector Class Declaration                                */
/*                                                                                 */
/***********************************************************************************/

#ifndef VECTOR_H
#define VECTOR_H

class Vector
{
public:
	float x, y, z;

	/*-----------Constructor--------*/

	Vector(float X = 0.0f, float Y = 0.0f, float Z = 0.0f);


	/*-----------Overloaded operators--------*/

	//Addition
	Vector operator+(const Vector &vec);
	Vector operator+=(const Vector &vec);

	//Subtraction
	Vector operator-(const Vector &vec);
	Vector operator-=(const Vector &vec);
	Vector operator-(void);

	//Scalar multiplication
	Vector operator*(float scale);
	Vector operator*=(float scale);

	//Scalar division
	Vector operator/(float num);
	Vector operator/=(float num);

	//Magnitude
	float getMagnitude(void);
};

#endif